Bug 50620 - Session related errors prevent clean recycle of Request and Response objects by CoyoteAdapter
Session related errors prevent clean recycle of Request and Response objects ...
Product: Tomcat 5
Classification: Unclassified
Component: Catalina
All All
: P2 major (vote)
: ---
Assigned To: Tomcat Developers Mailing List
Depends on:
  Show dependency tree
Reported: 2011-01-19 15:54 UTC by vamsavardhana reddy
Modified: 2011-02-03 16:56 UTC (History)
0 users

Patch created against tomcat/tc6.0.x/trunk (1.78 KB, patch)
2011-01-19 15:54 UTC, vamsavardhana reddy
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description vamsavardhana reddy 2011-01-19 15:54:38 UTC
Created attachment 26521 [details]
Patch created against tomcat/tc6.0.x/trunk

Session related errors prevent clean recycle of org.apache.catalina.connector.Request and org.apache.catalina.connector.Response objects by CoyoteAdapter. In org.apache.catalina.connector.Request.recycle() method, if an exception is thrown by session.endAccess() call, request object recycling aborts failing to cleanup fully and leaving the request object in inconsistent state. Further requests processed by CoyoteAdapter.service() using this inconsistent request object result in request being redirected to the last url that resulted in inconsistent request object which is still holding on to wrong session and contexts.
Comment 1 Mark Thomas 2011-01-20 13:36:30 UTC
Thanks for the report.

Fixed in 7.0.x and will be in 7.0.7 onwards.

I used a slightly different patch but it does the same thing.

I have proposed a back-port of the fix for 6.0.x
Comment 2 Mark Thomas 2011-01-20 16:36:31 UTC
Fixed in 6.0.x and will be included in 6.0.31 onwards.
Comment 3 Konstantin Kolinko 2011-02-03 16:56:50 UTC
Fixed in 5.5 with r1066996 and will be in 5.5.33.